# ffmpeg-mka-thumbnailer

A quick .mka [thumbnailer for FreeDesktop](https://specifications.freedesktop.org/thumbnail-spec/thumbnail-spec-latest.html) (e.g. Nautilus)

## Dependencies
ffmpeg-mka-thumbnailer uses [FFmpeg](https://ffmpeg.org/) for accessing the cover attachments. This could also be replaced with [MKVToolNix](https://mkvtoolnix.download/). For parsing `ffprobe` output, [`jq`](https://jqlang.github.io/jq/) is used.

To convert the album cover to other formats (mainly PNG) [ImageMagick](https://imagemagick.org/) (`convert` tool) is used. This could probably be dropped in favour of FFmpeg.

The script itself is written in [ZSH](https://zsh.org/), although this could also be easily translated to Bash as well.

## Installation
Assuming all the dependencies are installed, you'll need to do the following:
 - Clone this repo or download the code
 - Copy `ffmpeg-mka-thumbnailer` into a folder that is in your desktop environment's `$PATH`, e.g. `/usr/local/bin/`
 - Copy `ffmpeg-mka.thumbnailer` into `~/.local/share/thumbnailers/`

For the thumbnailer to work, you'll need to restart your file manager and (optionally) clear your thumbnail cache:
 - e.g. `nautilus -q` for exiting all Nautilus instances
 - `rm -r ~/.cache/thumbnails/` or `rm ~/.cache/thumbnails/fail/*` for only the failed attempts

## License
This project is licensed under Apache 1.0. Issues and PRs are welcome!